"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
function getSExpressionImpl() {
    var Lexer = require('../grammar/sexpression/sexpressionLexer').sexpressionLexer;
    var Parser = require('../grammar/sexpression/sexpressionParser').sexpressionParser;
    var r = {
        Lexer: Lexer,
        Parser: Parser,
        mainRule: 'sexpr',
        mutate: mutate
    };
    return r;
}
exports.getSExpressionImpl = getSExpressionImpl;
function mutate(ast, impl) {
    // in the original grammar there are three types, ListContext, ItemContext and AtomContext. ItemContext is only used as an itermediary so we will deleting it. Actually what we do is removing Item, and renaning atom to item. We verify that children is exactly one, has a parent, and its type and text are ideantical to its childAlso we rename the types to be shorter.
    // So the grammar will be transformed format
    // L => ([I]...), I=>L|A,
    // L=>([I|A]...)
    function f(n, p) {
        var _a;
        // let mutated = false
        if (n.start === undefined) {
            delete n.start;
        }
        if (n.stop === undefined) {
            delete n.stop;
        }
        if (n.type === 'item') {
            p = p || n.parent;
            if (p) {
                if (n.children.length) {
                    var ni = p.children.findIndex(function (i) { return i === n; });
                    (_a = p.children).splice.apply(_a, [ni, 1].concat(n.children));
                    // const ci = n.children.findIndex(i=>i===c)
                    // const c = n.children[0]
                    // if (n.text === c.text) {
                    // we can mutate
                    // p.children = [c]
                    // c.parent = p
                    // mutated = true
                    // }
                    // else {
                    //TODO
                    // }
                }
                else {
                    //TODO
                }
            }
            else {
                //TODO
            }
        }
        else {
            //TODO
        }
        // n.type = n.type === 'ListContext' ? 'list' : 'atom'
        n.children.forEach(function (c) { return f(c, n); });
        return n;
    }
    return f(ast);
}
//# sourceMappingURL=sexpression.js.map